
attacksconfig = {

	naturalattacks : ["morsure",
		"griffe",
		"sabot",
		"coup",
		"serres",
		"cornes",
		"constriction",
		"engloutissement",
		"queue",
		"tentacule",
		"piétinement"],		
	damageAttacks : {
		"dégâts" : 2,
		"oxydante" : 2,
		"pourissante" : 2
	},
	keenMultiplier : 4,
	APMultiplier : 2,
	saveAttacks : {
		"assourdissante" : 2,
		"aveuglante" : 2,
		"désoriantante" : 3,
		"dévoreuse d'âme" : 5,
		"diminution de caractéristique" : 4,
		"enchevêtrante" : 2,
		"enrageante" : 2,
		"étourdissante" : 4,
		"fatigante" : 3,
		"nauséeuse" : 2,
		"paralysante" : 3,
		"pétrifiante" : 5,
		"ralentissante" : 3,
		"renversante" : 2,
		"sanglante" : 2,
		"traumatisante" : 3,
		"terrifiante" : 2,
		"vampirique" : 3
	},
	areaUpgrades : {
		/* name : [xp multiplier, distable unit, distance description] */
		"aura" : [3, 3, "m. de rayon"],
		"cône" : [2, 3, "m. de portée"],
		"ligne" : [1, 3, "m. de portée"],
		"projectile" : [1, 6, "m. de portée"],
		"regard" : [3, 0, ""],
		"souffle" : [3, 1.5, "m. d'incrément de souffle"]
	},
	parseAttack : function(title, description) {
		
		title = title.trim();
		description = description.trim();
		
		// step 1: determine type of attack
		var attack = null;
		
		// natural attack = talon II × 4 (stuff)
		if (title.match(/^(.+) [VIX]+( × \d+)?$/) != null) {
			var attackType = title.replace(/^(.+) [VIX]+( × \d+)?$/, "$1").toLowerCase().trim();
			if (attacksconfig.naturalattacks.indexOf(attackType) >= 0) {
				attack = new NaturalAttack();
			}			
		}		
		
		if (attack == null) {
			// get the first item of the description
			var semicolon = description.indexOf(";");
			var firstpart = description;
			if (semicolon > 0) {
				firstpart = description.substring(0, semicolon);
			}
			
			// damage attack = custom (rotting II; stuff)
			// save attack = custom (baffling II; stuff)
			if (firstpart.match(/^.+ [VIX]+$/) != null) {
				var attackType = firstpart.substring(0, firstpart.lastIndexOf(" ")).toLowerCase().trim();
				if (attacksconfig.damageAttacks[attackType] !== undefined) {
					attack = new DamageEOAttack();
				} else if (attacksconfig.saveAttacks[attackType] !== undefined) {
					attack = new SaveEOAttack();
				}
			}			
			
			if (attack == null) {
				// weapon attack = custom (custom)
				attack = new WeaponAttack();
			}
		}
		
		attack.parse(title, description);
		return attack;
	}
}

// base attack object
function Attack() {
	this.name = "";
}
// clone the attack
Attack.prototype.clone = function() {
	return null;
}
// get the attack type;
Attack.prototype.getAttackType = function() {
	return null;
}
// get the xp value for this attack
Attack.prototype.getxp = function() {
	return 0;
}
// get the dispaly version of this attack
Attack.prototype.display = function() {
	return "";
}
// get the form content to edit this attack
Attack.prototype.editForm = function() {
	return "";
}
// setup js events on the form
Attack.prototype.setupForm = function() {
}
// create an attack from the form on screen
Attack.prototype.updateFromForm = function() {
	return null;
}
// parse from stat block
Attack.prototype.parse = function(title, details) {
}

// base attack object
function WeaponAttack() {
	this.base = Attack;
	this.base();
	this.description = "les détails de l'arme vont ici";
}
WeaponAttack.prototype = new Attack();

// clone the attack
WeaponAttack.prototype.clone = function() {
	var attack = new WeaponAttack();
	attack.name = this.name;
	attack.description = this.description;
	return attack;
}
// get the attack type;
WeaponAttack.prototype.getAttackType = function() {
	return "WeaponAttack";
}
// get the dispaly version of this attack
WeaponAttack.prototype.display = function() {
	return this.name + " (" + this.description + ")";
}
// parse from stat block
WeaponAttack.prototype.parse = function(title, details) {
	this.name = title.trim();
	this.description = details.trim();
}
// get the form content to edit this attack
WeaponAttack.prototype.editForm = function() {
	var output = "<div id='attackEditForm'>";
	
	output += "Nom de l'arme:&nbsp;<input type='text' id='attackName' size='20' value='" + this.name +"'/>";
	output += "<br/>";
	
	output += "<br/><textarea id='attackDescription' rows='4' cols='50'>";
	output += this.description;
	output += "</textarea>";
	
	output += "<br/>";
	output += "<em>Les armes ne comptent pas dans les XP total.</em>";
	
	output += "</div>"
	return output;
}
// create an attack from the form on screen
WeaponAttack.prototype.updateFromForm = function() {
	this.name = npcutil.simpleSanitizeCustomText($("#attackEditForm #attackName").val());
	this.description = npcutil.simpleSanitizeCustomText($("#attackEditForm #attackDescription").val());
}

function NaturalAttack() {
	this.base = Attack;
	this.base();
	this.grade = 1;
	this.quantity = 1;
	this.aligned = "";
	this.damageType = config.damagetypes[7];
	this.armourPiercing = 0; // can be multiple
	this.bleed = 0;
	this.diseased = "";
	this.finesse = 0;
	this.grab = 0;
	this.keen = 0; // can be multiple
	this.reach = 0; // can be multiple
	this.trip = 0;
	this.venomous = "";
}
NaturalAttack.prototype = new Attack();

// clone the attack
NaturalAttack.prototype.clone = function() {
	var attack = new NaturalAttack();
	attack.name = this.name;
	attack.title = this.title;
	attack.grade = this.grade;
	attack.quantity = this.quantity;
	attack.aligned = this.aligned;
	attack.damageType = this.damageType;
	attack.armourPiercing = this.armourPiercing;
	attack.bleed = this.bleed;
	attack.diseased = this.diseased;
	attack.finesse = this.finesse;
	attack.grab = this.grab;
	attack.keen = this.keen;
	attack.reach = this.reach;
	attack.trip = this.trip;
	attack.venomous = this.venomous;
	return attack;
}
// get the attack type;
NaturalAttack.prototype.getAttackType = function() {
	return "NaturalAttack";
}
// get the xp value for this attack
NaturalAttack.prototype.getxp = function() {
	var xp = this.grade * 2 * this.quantity;
	
	if (this.damageType != "lethal") { xp += 2; }
	if (this.aligned.trim() != "") { xp += 2; }
	if (this.diseased.trim() != "") { xp += 2; }
	if (this.venomous.trim() != "") { xp += 2; }
	
	if (this.armourPiercing != 0) {
		xp += (this.armourPiercing / attacksconfig.APMultiplier) * 2;
	}
	xp += this.bleed * 2;
	xp += this.finesse * 2;
	xp += this.grab * 2;
	if (this.keen != 0) {
		xp += (this.keen / attacksconfig.keenMultiplier) * 2;
	}
	xp += this.reach * 2;
	xp += this.trip * 2;
	
	return xp;
}
// get the dispaly version of this attack
NaturalAttack.prototype.display = function() {
	var output = this.title.toCapCase() + " " + config.roman[this.grade];
	if (this.quantity > 1) {
		output += " × " + this.quantity;
	}
	
	var upgrades = " (";
	var upgraded = false;
	
	if (this.damageType != "lethal") {
		upgrades += "type de dégât: " + this.damageType;
		upgraded = true;
	}
	if (this.aligned != "") {
		if (upgraded) {
			upgrades += "; ";
		}
		upgrades += "aligné: " + this.aligned;
		upgraded = true;
	}
	if (this.diseased != "") {
		if (upgraded) {
			upgrades += "; ";
		}
		upgrades += "infectieuse: " + this.diseased;
		upgraded = true;
	}
	if (this.venomous != "") {
		if (upgraded) {
			upgrades += "; ";
		}
		upgrades += "venimeuse: " + this.venomous;
		upgraded = true;
	}
	if (this.armourPiercing > 0) {
		if (upgraded) {
			upgrades += "; ";
		}
		upgrades += "perforation d'armure " + this.armourPiercing;
		upgraded = true;
	}
	if (this.bleed > 0) {
		if (upgraded) {
			upgrades += "; ";
		}
		upgrades += "sanglante";
		upgraded = true;
	}
	if (this.finesse > 0) {
		if (upgraded) {
			upgrades += "; ";
		}
		upgrades += "finesse";
		upgraded = true;
	}
	if (this.grab > 0) {
		if (upgraded) {
			upgrades += "; ";
		}
		upgrades += "étreinte";
		upgraded = true;
	}
	if (this.keen > 0) {
		if (upgraded) {
			upgrades += "; ";
		}
		upgrades += "acéré " + this.keen;
		upgraded = true;
	}
	if (this.reach > 0) {
		if (upgraded) {
			upgrades += "; ";
		}
		upgrades += "allonge " + this.reach;
		upgraded = true;
	}
	if (this.trip > 0) {
		if (upgraded) {
			upgrades += "; ";
		}
		upgrades += "faucheuse";
		upgraded = true;
	}
	
	upgrades += ")";
	
	if (upgraded) {
		output += upgrades;
	}
	
	return output;
}
// parse from stat block
NaturalAttack.prototype.parse = function(title, details) {
	// if there is a quantity multiplier
	if (title.match(/.+( × \d+)$/) != null) {
		var lastSpace = title.lastIndexOf(" ");
		this.quantity = parseInt(title.substring(lastSpace+1).trim());
		// remove after the multiplier
		var multiply = title.lastIndexOf("×");
		title = title.substring(0, multiply).trim();
	}
	
	// split title into attack type and calibre
	var lastSpace = title.lastIndexOf(" ");
	this.title = title.substring(0, lastSpace).toLowerCase();
	this.grade = config.roman.indexOf(title.substring(lastSpace+1).trim());
	
	// parse details
	var detail = details.split(/;\s+/);
	for (var i = 0; i < detail.length; ++i) {
		var datum = detail[i].trim();
		if (datum.startsWith("type de dégât:")) {
			this.damageType = datum.substring(12).trim();
		} else if (datum.startsWith("aligné:")) {
			this.aligned = datum.substring(8).trim();
		} else if (datum.startsWith("infectieuse:")) {
			this.diseased = datum.substring(9).trim();
		} else if (datum.startsWith("venimeuse:")) {
			this.venomous = datum.substring(9).trim();
		} else if (datum.startsWith("perforation d'armure")) {
			this.armourPiercing = parseInt(datum.substring(15));
		} else if (datum == "sanglante") {
			this.bleed = 1;
		} else if (datum == "finesse") {
			this.finesse = 1;
		} else if (datum == "étreinte") {
			this.grab = 1;
		} else if (datum.startsWith("acéré")) {
			this.keen = parseInt(datum.substring(4));
		} else if (datum.startsWith("allonge")) {
			this.reach = parseInt(datum.substring(5));
		} else if (datum == "faucheuse") {
			this.trip = 1;
		}	
	}
}
// get the form content to edit this attack
NaturalAttack.prototype.editForm = function() {
	var output = "<div id='attackEditForm'>";
	
	// type selector
	output += npcutil.getListSelector("attackType", attacksconfig.naturalattacks, false, this.title);
	output += "&nbsp;";
	output += npcutil.getRomanSelector("attackGrade", 1, 5, this.grade);
	output += "&nbsp;×&nbsp;";
	output += npcutil.getNumericSelector("attackQuantity", 1, 99, this.quantity);
	output += "<hr/>"
	
	output += "type de dégât:&nbsp;" + npcutil.getListSelector("damagetype", config.damagetypes, false, this.damageType);
	output += "&nbsp;";
	output += "aligné:&nbsp;<input type='text' id='aligned'"
	output += "value='" + this.aligned + "'";
	output += " size='15'/>";
	output += "<br/>";
	output += "infectieuse:&nbsp;<input type='text' id='diseased'"
	output += "value='" + this.diseased + "'";
	output += " size='15'/>";
	output += "&nbsp;";
	output += "venimeuse:&nbsp;<input type='text' id='venomous'"
	output += "value='" + this.venomous + "'";
	output += " size='15'/>";
	output += "<br/>";
	
	output += "perforation d'armure:&nbsp;" + npcutil.getNumericSelector("attackAP", 0, 20, this.armourPiercing, false, attacksconfig.APMultiplier) + "&nbsp;";
	output += "acéré:&nbsp;" + npcutil.getNumericSelector("attackKeen", 0, 60, this.keen, false, attacksconfig.keenMultiplier) + "&nbsp;";
	output += "allonge:&nbsp;" + npcutil.getNumericSelector("attackReach", 0, 9, this.reach) + "&nbsp;";
	output += "<br/>";
	
	output += "<input type='checkbox' id='attackBleed'";
	if (this.bleed == 1) { output += " checked='checked'" };
	output += "/><label for='attackBleed'>sanglante</label>";
	
	output += "&nbsp;<input type='checkbox' id='attackFinesse'";
	if (this.finesse == 1) { output += " checked='checked'" };
	output += "/><label for='attackFinesse'>finesse</label>";
	
	output += "&nbsp;<input type='checkbox' id='attackGrab'";
	if (this.grab == 1) { output += " checked='checked'" };
	output += "/><label for='attackGrab'>étreinte</label>";
	
	output += "&nbsp;<input type='checkbox' id='attackTrip'";
	if (this.trip == 1) { output += " checked='checked'" };
	output += "/><label for='attackTrip'>faucheuse</label>";
	
	output += "</div>";
	
	return output;
}
// create an attack from the form on screen
NaturalAttack.prototype.updateFromForm = function() {
	this.title = $("#attackEditForm #attackType").val();
	this.grade = parseInt($("#attackEditForm #attackGrade").val());
	this.quantity = parseInt($("#attackEditForm #attackQuantity").val());
	this.aligned = npcutil.sanitizeCustomText($("#attackEditForm #aligned").val());
	this.damageType = $("#attackEditForm #damagetype").val();
	this.armourPiercing = parseInt($("#attackEditForm #attackAP").val());
	this.bleed = $("#attackEditForm #attackBleed").attr("checked") ? 1 : 0;
	this.diseased = npcutil.sanitizeCustomText($("#attackEditForm #diseased").val());
	this.finesse = $("#attackEditForm #attackFinesse").attr("checked") ? 1 : 0;
	this.grab = $("#attackEditForm #attackGrab").attr("checked") ? 1 : 0;
	this.keen = parseInt($("#attackEditForm #attackKeen").val());;
	this.reach = parseInt($("#attackEditForm #attackReach").val());
	this.trip = $("#attackEditForm #attackTrip").attr("checked") ? 1 : 0;
	this.venomous = npcutil.sanitizeCustomText($("#attackEditForm #venomous").val());
}


// damage extraordinatry attack
function DamageEOAttack() {
	this.base = Attack;
	this.base();
	this.grade = 1;
	this.title = "dégâts";
	this.name = "non défini";
	this.aligned = "";
	this.damageType = config.damagetypes[7];
	this.armourPiercing = 0; // can be multiple
	this.bleed = 0;
	this.diseased = "";
	this.keen = 0; // can be multiple
	this.venomous = "";
	this.area = "";
	this.areaQuantity = 1;
}
DamageEOAttack.prototype = new Attack();

// clone the attack
DamageEOAttack.prototype.clone = function() {
	var attack = new DamageEOAttack();
	attack.title = this.title;
	attack.grade = this.grade;
	attack.name = this.name;
	attack.aligned = this.aligned;
	attack.damageType = this.damageType;
	attack.armourPiercing = this.armourPiercing;
	attack.bleed = this.bleed;
	attack.diseased = this.diseased;
	attack.keen = this.keen;
	attack.venomous = this.venomous;
	attack.area = this.area;
	attack.areaQuantity = this.areaQuantity;
	return attack;
}
// get the attack type;
DamageEOAttack.prototype.getAttackType = function() {
	return "DamageEOAttack";
}
// get the xp value for this attack
DamageEOAttack.prototype.getxp = function() {
	var xp = attacksconfig.damageAttacks[this.title] * this.grade;
	
	if (this.damageType != "lethal") { xp += 2; }
	if (this.aligned.trim() != "") { xp += 2; }
	if (this.diseased.trim() != "") { xp += 2; }
	if (this.venomous.trim() != "") { xp += 2; }
	
	if (this.armourPiercing != 0) {
		xp += (this.armourPiercing / attacksconfig.APMultiplier) * 2;
	}
	xp += this.bleed * 2;
	if (this.keen != 0) {
		xp += (this.keen / attacksconfig.keenMultiplier) * 2;
	}
	if (this.area != "") {
		xp += attacksconfig.areaUpgrades[this.area][0] * this.areaQuantity;
	}
	
	return xp;
}
// get the dispaly version of this attack
DamageEOAttack.prototype.display = function() {
	var output = this.name + " (" + this.title + " " + config.roman[this.grade];
	
	if (this.area != "") {
		output += "; " + this.area;
		if (this.area != "gaze") {
			output += " " + this.areaQuantity * attacksconfig.areaUpgrades[this.area][1];
			output += attacksconfig.areaUpgrades[this.area][2]
		}
	}
	if (this.damageType != "lethal") {
		output += "; type de dégât: " + this.damageType;
	}
	if (this.aligned != "") {
		output += "; aligné: " + this.aligned;
	}
	if (this.diseased != "") {
		output += "; infectieuse: " + this.diseased;
	}
	if (this.venomous != "") {
		output += "; venimeuse: " + this.venomous;
	}
	if (this.armourPiercing > 0) {
		output += "; perforation d'armure " + this.armourPiercing;
	}
	if (this.bleed > 0) {
		output += "; sanglante";
	}
	if (this.keen > 0) {
		output += "; acéré " + this.keen;
	}
	
	
	output += ")";
	
	return output;
}
// parse from stat block
DamageEOAttack.prototype.parse = function(title, details) {
	this.name = title;
	
	// parse details
	var detail = details.split(/;\s+/);
	
	// split title into attack type and calibre
	var lastSpace = detail[0].lastIndexOf(" ");
	this.title = detail[0].substring(0, lastSpace);
	this.grade = config.roman.indexOf(detail[0].substring(lastSpace+1).trim());
	
	for (var i = 1; i < detail.length; ++i) {
		var datum = detail[i].trim();
		if (datum.startsWith("type de dégât:")) {
			this.damageType = datum.substring(12).trim();
		} else if (datum.startsWith("aligné:")) {
			this.aligned = datum.substring(8).trim();
		} else if (datum.startsWith("infectieuse:")) {
			this.diseased = datum.substring(9).trim();
		} else if (datum.startsWith("venimeuse:")) {
			this.venomous = datum.substring(9).trim();
		} else if (datum.startsWith("perforation d'armure")) {
			this.armourPiercing = parseInt(datum.substring(15));
		} else if (datum == "sanglante") {
			this.bleed = 1;
		} else if (datum.startsWith("acéré")) {
			this.keen = parseInt(datum.substring(4));
		} else {
			// is this is an area type
			for (var j in attacksconfig.areaUpgrades) {
				if (datum.startsWith(j)) {
					this.area = j;
					if (this.area == "gaze") {
						this.areaQuantity = 1;
					} else {
						var distance = parseInt(datum.substring(datum.indexOf(" "), datum.indexOf("ft")));
						this.areaQuantity = distance / attacksconfig.areaUpgrades[this.area][1];
					}
				}
			}			
		}
	}
}
// get the form content to edit this attack
DamageEOAttack.prototype.editForm = function() {
	var output = "<div id='attackEditForm'>";
	
	output += "Nom de l'Attaque:&nbsp;<input type='text' id='attackName' size='20' value='" + this.name +"'/>&nbsp;";
	
	// type selector
	output += npcutil.getListKeySelector("attackType", attacksconfig.damageAttacks, false, this.title);
	output += "&nbsp;";
	output += npcutil.getRomanSelector("attackGrade", 1, 5, this.grade);
	output += "<hr/>"
	
	output += "type de dégât:&nbsp;" + npcutil.getListSelector("damagetype", config.damagetypes, false, this.damageType);
	output += "&nbsp;";
	output += "aligné:&nbsp;<input type='text' id='aligned'"
	output += "value='" + this.aligned + "'";
	output += " size='15'/>";
	output += "<br/>";
	output += "infectieuse:&nbsp;<input type='text' id='diseased'"
	output += "value='" + this.diseased + "'";
	output += " size='15'/>";
	output += "&nbsp;";
	output += "venimeuse:&nbsp;<input type='text' id='venomous'"
	output += "value='" + this.venomous + "'";
	output += " size='15'/>";
	output += "<br/>";
	
	output += "perforation d'armure:&nbsp;" + npcutil.getNumericSelector("attackAP", 0, 20, this.armourPiercing, false, attacksconfig.APMultiplier) + "&nbsp;";
	output += "acéré:&nbsp;" + npcutil.getNumericSelector("attackKeen", 0, 60, this.keen, false, attacksconfig.keenMultiplier) + "&nbsp;";
		
	output += "<br/>";
	
	output += "<input type='checkbox' id='attackBleed'";
	if (this.bleed == 1) { output += " checked='checked'" };
	output += "/><label for='attackBleed'>sanglante</label>";
	
	output += "<span class='attackUpgradeOption'>";
	output += "zone d'effet:";
	output += "&nbsp;";
	output += npcutil.getListKeySelector("attackAreaType", attacksconfig.areaUpgrades, true, this.area);
	output += "&nbsp;";
	output += "<span id='areaUnitDescription'>";
	if (this.area != "gaze" && this.area != "") {
		output +=  attacksconfig.areaUpgrades[this.area][1] + " " +  attacksconfig.areaUpgrades[this.area][2]
	}
	output += "</span>";
	var disabled = false;
	if (this.area == "gaze") {
		disabled = true;
	}
	output += "&nbsp;×&nbsp;" + npcutil.getNumericSelector("attackAreaMultiplier", 1, 9, this.areaQuantity, disabled);
	output += "</span>";
		
	output += "</div>";
	
	return output;
}
// setup js events on the form
DamageEOAttack.prototype.setupForm = function() {
	
	var attackInstance = this;
		
	$("#attackEditForm #attackAreaType").change(function(){
		attackInstance.updateAreaSelector();
	});
	attackInstance.updateAreaSelector();
}
DamageEOAttack.prototype.updateAreaSelector = function() {
		var areaType = $("#attackEditForm #attackAreaType").val();
		if (areaType == "gaze" || areaType == "") {
			$("#areaUnitDescription").html("");
			$("#attackEditForm #attackAreaMultiplier").disable();
		} else {
			$("#areaUnitDescription").html(attacksconfig.areaUpgrades[areaType][1] + " " +  attacksconfig.areaUpgrades[areaType][2]);
			$("#attackEditForm #attackAreaMultiplier").enable();
		}
}
// create an attack from the form on screen
DamageEOAttack.prototype.updateFromForm = function() {
	this.name = npcutil.sanitizeCustomText($("#attackEditForm #attackName").val());
	this.title = $("#attackEditForm #attackType").val();
	this.grade = parseInt($("#attackEditForm #attackGrade").val());
	this.aligned = npcutil.sanitizeCustomText($("#attackEditForm #aligned").val());
	this.damageType = $("#attackEditForm #damagetype").val();
	this.armourPiercing = parseInt($("#attackEditForm #attackAP").val());
	this.bleed = $("#attackEditForm #attackBleed").attr("checked") ? 1 : 0;
	this.diseased = npcutil.sanitizeCustomText($("#attackEditForm #diseased").val());
	this.keen = parseInt($("#attackEditForm #attackKeen").val());
	this.venomous = npcutil.sanitizeCustomText($("#attackEditForm #venomous").val());
	this.area = $("#attackEditForm #attackAreaType").val();
	this.areaQuantity = parseInt($("#attackEditForm #attackAreaMultiplier").val());
}

// save extraordinary attack
function SaveEOAttack() {
	this.base = Attack;
	this.base();
	this.grade = 1;
	this.title = "assourdissante";
	this.name = "non défini";
	this.supernaturalAttack = "";
	this.area = "";
	this.areaQuantity = 1;
}
SaveEOAttack.prototype = new Attack();

// clone the attack
SaveEOAttack.prototype.clone = function() {
	var attack = new SaveEOAttack();
	attack.title = this.title;
	attack.grade = this.grade;
	attack.name = this.name;
	attack.supernaturalAttack = this.supernaturalAttack;
	attack.area = this.area;
	attack.areaQuantity = this.areaQuantity;
	return attack;
}
// get the attack type;
SaveEOAttack.prototype.getAttackType = function() {
	return "SaveEOAttack";
}
// get the xp value for this attack
SaveEOAttack.prototype.getxp = function() {
	var xp = attacksconfig.saveAttacks[this.title] * this.grade;
	
	if (this.supernaturalAttack != "") {
		xp += 2;
	} else if (this.area != "") {
		xp += attacksconfig.areaUpgrades[this.area][0] * this.areaQuantity;
	}
	
	return xp;
}
// get the dispaly version of this attack
SaveEOAttack.prototype.display = function() {
	var output = this.name + " (" + this.title + " " + config.roman[this.grade];
	
	if (this.supernaturalAttack != "") {
		output += "; Lié à l'attaque " + this.supernaturalAttack;
	} else if (this.area != "") {
		output += "; " + this.area;
		if (this.area != "gaze") {
			output += " " + this.areaQuantity * attacksconfig.areaUpgrades[this.area][1];
			output += attacksconfig.areaUpgrades[this.area][2]
		}
	}
	
	output += ")";
	
	return output;
}
// parse from stat block
SaveEOAttack.prototype.parse = function(title, details) {
	this.name = title;
	
	// parse details
	var detail = details.split(/;\s+/);
	
	// split title into attack type and calibre
	var lastSpace = detail[0].lastIndexOf(" ");
	this.title = detail[0].substring(0, lastSpace);
	this.grade = config.roman.indexOf(detail[0].substring(lastSpace+1).trim());
	
	for (var i = 1; i < detail.length; ++i) {
		var datum = detail[i].trim();
		if (datum.startsWith("lié à l'attaque")) {
			this.supernaturalAttack = datum.substring(16).trim();
		} else {
			// is an area upgrade
			var nextspace = datum.indexOf(" ")
			if (nextspace > 0) {
				this.area = datum.substring(0, nextspace).trim().toLowerCase();
			} else {
				this.area = datum.trim().toLowerCase();
			}
			if (this.area == "gaze") {
				this.areaQuantity = 1;
			} else {
				var distance = parseInt(datum.substring(datum.indexOf(" "), datum.indexOf("ft")));
				this.areaQuantity = distance / attacksconfig.areaUpgrades[this.area][1];
			}
		}
	}
}
// get the form content to edit this attack
SaveEOAttack.prototype.editForm = function() {
	var output = "<div id='attackEditForm'>";
	
	output += "Nom de l'Attaque:&nbsp;<input type='text' id='attackName' size='20' value='" + this.name +"'/>&nbsp;";
	
	// type selector
	output += npcutil.getListKeySelector("attackType", attacksconfig.saveAttacks, false, this.title);
	output += "&nbsp;";
	output += npcutil.getRomanSelector("attackGrade", 1, 5, this.grade);
	output += "<hr/>"
	
	output += "<div id='attackOptions'>";
	output += "<input type='radio' id='hasNoUpgrade' name='attackUpgrade'";
	if (this.supernaturalAttack == "" && this.area == "") {
		output += " checked='checked'";
	}
	output += "/><label for='hasNoUpgrade'>Pas d'amélioration</label>";
	output += "<br/>";
	output += "<input type='radio' id='isAttackUpgrade' name='attackUpgrade'";
	if (this.supernaturalAttack != "") {
		output += " checked='checked'";
	}
	output += "/><label for='isAttackUpgrade'>Attaque surnaturelle</label>";
	output += "<br/>";
	output += "<span class='attackUpgradeOption'>";
	output += "Lié à: <input type='text' id='linkedAttack' size='20' value='" + this.supernaturalAttack + "'/>"
	output += "</span>";
		
	output += "<br/>";
	output += "<input type='radio' id='isAreaUpgrade' name='attackUpgrade'";
	if (this.area != "") {
		output += " checked='checked'";
	}
	output += "/><label for='isAreaUpgrade'>Zone d'effet</label>";
	output += "<br/>";
	output += "<span class='attackUpgradeOption'>";
	var areaToUseInForm = this.area;
	if (areaToUseInForm == "") {
		areaToUseInForm = "aura";
	}
	output += npcutil.getListKeySelector("attackAreaType", attacksconfig.areaUpgrades, false, areaToUseInForm);
	output += "&nbsp;";
	output += "<span id='areaUnitDescription'>";
	if (this.area != "gaze") {
		output +=  attacksconfig.areaUpgrades[areaToUseInForm][1] + " " +  attacksconfig.areaUpgrades[areaToUseInForm][2]
	}
	output += "</span>";
	var disabled = false;
	if (this.area == "gaze") {
		disabled = true;
	}
	output += "&nbsp;×&nbsp;" + npcutil.getNumericSelector("attackAreaMultiplier", 1, 9, this.areaQuantity, disabled);
	output += "</span>";
	
	output += "</div>";
	
	output += "</div>";
	
	return output;
}
// setup js events on the form
SaveEOAttack.prototype.setupForm = function() {
	
	var attackInstance = this;
	attackInstance.updateFormState();
	
	// bing events to make the extraordinary attack form dynamic
	$("#attackEditForm input[type='radio']").click(function(){
		attackInstance.updateFormState();
	});
	
	$("#attackEditForm #attackAreaType").change(function(){
		var areaType = $("#attackEditForm #attackAreaType").val();
		if (areaType == "gaze") {
			$("#areaUnitDescription").html("");
			$("#attackEditForm #attackAreaMultiplier").disable();
		} else {
			$("#areaUnitDescription").html(attacksconfig.areaUpgrades[areaType][1] + " " +  attacksconfig.areaUpgrades[areaType][2]);
			$("#attackEditForm #attackAreaMultiplier").enable();
		}
	});
}
SaveEOAttack.prototype.updateFormState = function() {
	
	if ($("#attackEditForm #hasNoUpgrade").attr("checked")) {
		$("#attackEditForm #linkedAttack").disable();
		$("#attackEditForm #attackAreaType").disable();
		$("#attackEditForm #attackAreaMultiplier").disable();
	} else if ($("#attackEditForm #isAttackUpgrade").attr("checked")) {
		$("#attackEditForm #linkedAttack").enable();
		$("#attackEditForm #attackAreaType").disable();
		$("#attackEditForm #attackAreaMultiplier").disable();
	} else {
		$("#attackEditForm #linkedAttack").disable();
		$("#attackEditForm #attackAreaType").enable();
		var areaType = $("#attackEditForm #attackAreaType").val();
		if (areaType != "gaze") {
			$("#attackEditForm #attackAreaMultiplier").enable();
		}
	}
}
// create an attack from the form on screen
SaveEOAttack.prototype.updateFromForm = function(parentDivId) {
	this.name = npcutil.sanitizeCustomText($("#attackEditForm #attackName").val());
	this.title = $("#attackEditForm #attackType").val();
	this.grade = parseInt($("#attackEditForm #attackGrade").val());
	
	if ($("#attackEditForm #hasNoUpgrade").attr("checked")) {
		this.supernaturalAttack = "";
		this.area = "";
		this.areaQuantity = 1;
	} else if ($("#attackEditForm #isAttackUpgrade").attr("checked")) {
		this.supernaturalAttack = $("#attackEditForm #linkedAttack").val();
		this.area = "";
		this.areaQuantity = 1;
	} else {
		this.supernaturalAttack = "";
		this.area = $("#attackEditForm #attackAreaType").val();
		this.areaQuantity = parseInt($("#attackEditForm #attackAreaMultiplier").val());
	}
}
