
function EditAttacksDialog() {
	this.base = NPCDialog;
	this.base("Edit Attacks/Weapons", false, "edit-attacka-dialog");
}
EditAttacksDialog.prototype = new NPCDialog();

EditAttacksDialog.prototype.close = function() {
	this.base.prototype.close.call(this);
	view.reviewEditAttacksButton();
}

EditAttacksDialog.prototype.edit = function() {
	// Identify index of attack selected
	var index = parseInt($("#attacksList").val());
	// Get the attack
	var attack = npc.getAttack(index);
	// Create an edit dialog for this attack
	var editAttackDialog = new AttackDialog("Edit Attack", attack, index);
	// Open the dialog
	editAttackDialog.open();
}

EditAttacksDialog.prototype.remove = function() {
	// Identify index of attack selected
	var index = parseInt($("#attacksList").val());
	// Remove the attack
	npc.removeAttack(index);
}

EditAttacksDialog.prototype.getButtons = function() {
	var dialogInstance = this;
	
	return { 
		"Edit..." : function() { 
			dialogInstance.edit();
			dialogInstance.close();
		}, 
		"Remove" : function() {
			dialogInstance.remove();
			dialogInstance.close();
			view.renderNPC();				
		},
		"Annuler" : function() { 
			dialogInstance.close();
		}
	}
}

EditAttacksDialog.prototype.getFormContent = function() {
	// Create a selector listing all the qualities with section title.
	var output = "";
	
	// create the selector
	output += "<select id='attacksList' size='8'>";
	// get the list of attacks
	var attacks = npc.getAttacks();
	
	// all the weapon attacks
	output += "<optgroup label='Weapons'>";
	for (var i = 0; i < attacks.length; ++i) {
		if (attacks[i].getAttackType() == "WeaponAttack") {
			output += "<option value='"+i+"'>" + attacks[i].display() + "</option>";
		}
	}
	output += "</optgroup>"
	
	// all the natural attacks
	output += "<optgroup label='Natural Attacks'>";
	for (var i = 0; i < attacks.length; ++i) {
		if (attacks[i].getAttackType() == "NaturalAttack") {
			output += "<option value='"+i+"'>" + attacks[i].display() + "</option>";
		}
	}
	output += "</optgroup>"
	
	// all the damage extraordinary attacks
	output += "<optgroup label='Damage Extraordinary Attacks'>";
	for (var i = 0; i < attacks.length; ++i) {
		if (attacks[i].getAttackType() == "DamageEOAttack") {
			output += "<option value='"+i+"'>" + attacks[i].display() + "</option>";
		}
	}
	output += "</optgroup>"
	
	// all the save extraordinary attacks
	output += "<optgroup label='Save Extraordinary Attacks'>";
	for (var i = 0; i < attacks.length; ++i) {
		if (attacks[i].getAttackType() == "SaveEOAttack") {
			output += "<option value='"+i+"'>" + attacks[i].display() + "</option>";
		}
	}
	output += "</optgroup>"
	
	output += "</select>";
	
	return output;
}
