
mobilitymanager = {

	names : ["Marchant", "Creusant", "Volant", "Nageant", "Immobile"],

	defaults : {
		"Marchant" : new Mobility(0, [9, 0, 0, 0]),
		"Creusant" : new Mobility(1, [0, 9, 0, 0]),
		"Volant" : new Mobility(2, [0, 0, 9, 0]),
		"Nageant" : new Mobility(3, [0, 0, 0, 9]),
		"Immobile" :  new Mobility(4, [0, 0, 0, 0])
	}
}

function Mobility(primary, speeds)	{
	this.primary = primary;
	this.speeds = speeds;
}

Mobility.prototype.clone = function() {
	var clone = new Mobility(0, [0, 0, 0, 0]);
	clone.primary = this.primary;
	clone.speeds = this.speeds;
	return clone;
}

Mobility.prototype.getxp = function() {
	var xp = 0;
	
	// base xp by primary mobility type
	xp = config.mobility[mobilitymanager.names[this.primary]];
	
	// if not immobile
	if (this.primary < 4) {
		// default for mobility type
		for (var i = 0; i < 4; ++i) {
			if (i == this.primary) {
				if (this.speeds[i] > 9) {
					xp += (this.speeds[i] - 9) / 3;
				}
			} else {
				xp += this.speeds[i] / 3;
			}			
		}
	}
	return xp;
}

Mobility.prototype.displayName = function() {
	var name = "";
	
	name = mobilitymanager.names[this.primary];
	
	// if not immobile
	if (this.primary < 4) {
		for (var i = 0; i < 4; ++i) {
			if (i != this.primary && this.speeds[i] > 0) {
				name += "/" + mobilitymanager.names[i];
			}
		}
	}
		
	return name;
}

Mobility.prototype.isImmobile = function() {
	if (this.primary < 4) {
		return false;
	} else {
		return true;
	}
}

