
function MobilityDialog() {
	this.base = NPCDialog;
	this.base("Mouvement", true, "edit-mobility-form");
}
MobilityDialog.prototype = new NPCDialog();

MobilityDialog.prototype.ok = function() {
	var mobility = this.getMobilityFromDialog();
	npc.setMobility(mobility);
}

MobilityDialog.prototype.open = function() {
	this.base.prototype.open.call(this);
	
	var dialogInstance = this;
	
	// attach form changing event to mobility type selector
	$("#mobilityType").change(function(){
		var type = $("#mobilityType").val();
		var mobility = dialogInstance.getMobilityFromDialog();
		$("#editmobilityarea").html(dialogInstance.formFromMobility(mobility));
		$("#selectmobilityarea").styleInputs();
		dialogInstance.readForm();
		
		$("#editmobilityarea select").change(function() {
			dialogInstance.readForm();
		});
	
	});
	
	$("#editmobilityarea select").change(function() {
		dialogInstance.readForm();
	});
	
	$("#selectmobilityarea").styleInputs();
	
	dialogInstance.readForm();
}

MobilityDialog.prototype.getFormContent = function() {
		
	var output = "<div id='selectmobilityarea'>";
		
	// Mobility type selector
	output += npcutil.getListKeySelector("mobilityType", config.mobility, false, mobilitymanager.names[npc.getMobility().primary]);
	
	output += "<div id='editmobilityarea'>";
	
	output += this.formFromMobility(npc.getMobility());
		
	output += "</div>";
	
	output += "</div>";
	
	return output;
}

MobilityDialog.prototype.formFromMobility = function(mobility) {
	
	var output = "";
	
	if (mobility.isImmobile()) {
		// if immobile, do nothing
	} else {
		// output all four speed boxes
		
		// walk
		output += "<span class='typetitle'>Vitesse au Sol:</span>" + npcutil.getNumericSelector("walkspeed", 0, 100, mobility.speeds[0], false, 3);
		output += "<br/>";
		
		// burrow
		output += "<span class='typetitle'>Vitesse en Creusant:</span>" + npcutil.getNumericSelector("burrowspeed", 0, 100, mobility.speeds[1], false, 3);
		output += "<br/>";
		
		// fly
		output += "<span class='typetitle'>Vitesse en Vol:</span>" + npcutil.getNumericSelector("flyspeed", 0, 100, mobility.speeds[2], false, 3);
		output += "<br/>";
				
		// swim
		output += "<span class='typetitle'>Vitesse en Nageant:</span>" + npcutil.getNumericSelector("swimspeed", 0, 200, mobility.speeds[3], false, 3);
		
	}
	
	return output;
}

MobilityDialog.prototype.readForm = function() {
	var mobility = this.getMobilityFromDialog();
	this.updateXP(mobility.getxp());
}

MobilityDialog.prototype.getMobilityFromDialog = function() {
	
	// start with default instance	
	var mobility = mobilitymanager.defaults[$("#mobilityType").val()];
	
	// is there a walk speed selector
	if ($("#walkspeed").length > 0) {
		mobility.speeds[0] = parseInt($("#walkspeed").val());
	}
	
	// is there a burrow speed selector
	if ($("#burrowspeed").length > 0) {
		mobility.speeds[1] = parseInt($("#burrowspeed").val());
	}
	
	// is there a fly speed selector
	if ($("#flyspeed").length > 0) {
		mobility.speeds[2] = parseInt($("#flyspeed").val());
	}
	
	// is there a swim speed selector
	if ($("#swimspeed").length > 0) {
		mobility.speeds[3] = parseInt($("#swimspeed").val());
	}
	
	return mobility;
	
}
