
/*
 * Patters to be filled with random words from the following table.
 * 
 * Special Characters
 * | - choose randomly from the following two
 * [ - copy content verbatum until ]
 * 
 * If the first word ends with the first letter of the
 * second word, and they are not pre/suff, then the duplicate letter could be removed.
 */
patternTable = {
	"Drake" : { 1 : "D[-]B", 7 : "GB", 13 : "H B", 19 : "OO [le/la] A"},
	"Nain" : { 1 : "L AE", 9 : "L BE", 17 : "L JD", 19 : "M A[-]G"},
	"Elfe" : { 1 : "KK C[-]E", 7 : "KK BD", 13 : "KK A F", 19 : "KK [le/la] JH"},
	"Géant" : { 1 : "M AD", 9 : "L BD", 13 : "L DE", 17 : "DA [le/la] I"},
	"Gobelin" : { 1 : "NN", 9 : "N O", 13 : "NN [le/la] C", 17 : "NO [le/la] G"},
	"Humain" : { 1 : "|LM C H", 9 : "|LM CB", 13 : "|LM KK", 17 : "IM [le/la] J"},
	"Ogre" : { 1 : "AB", 8 : "AG", 15 : "JI", 18 : "NK BI"},
	"Orque" : { 1 : "NN J[-]G", 9 : "NN AC", 13 : "NN AH", 17 : "NN [le/la] J I"},
	"Halfelin" : { 1 : "M F H", 9 : "L C[-]E", 13 : "L FD", 17 : "M FE"},
	"Sylvanien" : { 1 : "BF", 6 : "F G", 11 : "F [de la] H", 16 : "FD"},
	"Saurien" : { 1 : "OO", 9 : "OO BE", 13 : "OO AF", 17 : "OO C[-]D"},
	"Artificiel" : { 1 : "KO", 5 : "JH", 11 : "CG[de] M", 16 : "C E [-] Z"},	
};

/*
 * This table can be used as the one in the book except that the arrays are numbered 0..19
 */
nameTable = {
		
	"A" : ["Appelle", "Arpente", "Bâtit", "Brise", "Broie", "Chante", "Cherche", "Guide", "Gratte", "Mange", "Marche", "Massacre", "Parie", "Porte", "Prend", "Sent", "Suit", "Tranche", "Veille", "Voit"],
			
	"B" : ["Aile", "Barbe", "Bras", "Chair", "Coeur", "Crâne", "Crête", "Croc", "Dent", "Dos", "Echine", "Fourrure", "Griffe", "Mâchoire", "Main", "Oeil", "Pied", "Poing", "Souffle", "Tête"],
	
	"C" : ["Aigle", "Ange", "Belette", "Cerf", "Cheval", "Corbeau", "Corneille", "Diable", "Dragon", "Faucon", "Homme", "Lion", "Loup", "Molosse", "Monstre", "Rat", "Requin", "Sanglier", "Serpent", "Tigre"],
	
	"D" : ["Aube", "Ciel", "Colline", "Crépuscule", "Eclair", "Etoile", "Feu", "Flamme", "Givre", "Lune", "Mer", "Montagne", "Nuage", "Pierre", "Pluie", "Soleil", "Tempête", "Terre", "Tonnerre", "Vent"],
	
	"E" : ["Acier", "Adamantine", "Argent", "Bronze", "Cuivre", "Diamant", "Emeraude", "Etain", "Fer", "Foyer", "Gemme", "Granite", "Jade", "Minerai", "Mithral", "Onyx", "Opale", "Or", "Rubis", "Saphir"],

	"F" : ["Arbre", "Bosquet", "Branche", "Brindille", "Caverne", "Chêne", "Epine", "Feuille", "Fleur", "Forêt", "Herbe", "Mousse", "Orme", "Pin", "Printemps", "Racine", "Rivière", "Saule", "Vallée", "Vigne"],
	
	"G" : ["Brisé", "Cendre", "Déchiqueté", "Fétide", "Fléau", "Flétrir", "Gris", "Malédiction", "Miasme", "Mort", "Noir", "Nuit", "Ombre", "Os", "Rouge", "Sang", "Sombre", "Ténèbre", "Venin", "Vil"],
	
	"H" : ["Âme", "Aube", "Bénédiction", "Blanc", "Bleu", "Courageux", "Eté", "Gloire", "Héros", "Jour", "Juste", "Loi", "Lumière", "Printemps", "Pur", "Roi", "Soleil", "Vérité", "Vert", "Voeu"],
	
	"I" : ["Assassin", "Bâtard", "Beau", "Borgne", "Chanceux", "Conquérant", "Cruel", "Enjoué", "Estropié", "Flatulent", "Fou", "Gros", "Magnifique", "Maléfique", "Malin", "Puissant", "Rapide", "sanglant", "Sauvage", "Terrible"],
	
	"J" : ["Arc", "Bâton", "Bouclier", "Couteau", "Dague", "Enclume", "Epée", "Flèche", "forge", "Garde", "Hache", "Harpon", "Lame", "Lance", "Marteau", "Masse", "Pique", "Pointe", "Roue", "Scie"],
	
	"K" : {
		"pre" : ["Aen", "Ala", "And", "Ar", "Cas", "Cyl", "El", "Eln", "Fir", "Gael", "Hu", "Koeh", "Laer", "Lue", "Nai", "Rhy", "Sere", "Tia", "Tele", "Zau"],
		"suff" : ["ael", "ari", "eth", "dil", "eil", "evar", "ir", "mus", "oth", "rad", "re", "riel", "rond", "sar", "sil", "tahl", "thus", "uil", "vain", "wyn"]
	},
	
	"L" : {
		"mâle" : ["Bjorn", "Dalgar", "Einar", "Fulnir", "Garth", "Galinn", "Geir", "Hakon", "Hamar", "Hrothgar", "Ivar", "Kell", "Magne", "Oddvar", "Ranulf", "Sigurd", "Snorri", "Tarn", "Tor", "Wulf"],
		"femelle" : ["Asta", "Bodil", "Dagmar", "Emla", "Flos", "Freya", "Ginna", "Gunnhild", "Haldis", "Helga", "Idona", "Inge", "Liva", "Norna", "Ragnhild", "Sigrun", "Solveig", "Thoris", "Valda", "Unni"]
	},
	
	"M" : {
		"mâle" : ["Aiden", "Bruce", "Dirk", "Gareth", "Gregor", "Gustav", "Halsten", "Harold", "Jack", "James", "Kirk", "Lief", "Liam", "Patrick", "Robert", "Ronan", "Seth", "Steven", "Tom", "William"],
		"femelle" : ["Abby", "Bridget", "Cate", "Daisy", "Helen", "Hilda", "Ingrid", "Jessica", "Linnea", "Maggie", "Natalia", "Olga", "Rebecca", "Raelia", "Rose", "Sarah", "Scarlett", "Sophia", "Tamara", "Violet"]
	},
	
	"N" : {
		"pre" : ["Blud", "Bruh", "Dirg", "Dur", "Gaz", "Gor", "Goth", "Gut", "Lor", "Luth", "Mag", "Nar", "Nug", "Od", "Og", "Skum", "Teg", "Was", "Wort", "Yag"],
		"suff" : ["bag", "brak", "dar", "dreg", "gar", "gog", "ghul", "git", "grub", "ok", "rak", "rot", "ruk", "sarg", "shak", "sot", "tek", "thag", "tor", "zod"]
	},
	
	"O" : {
		"pre" : ["Geth", "Grath", "Gyss", "Hyss", "Kla", "Lath", "Lex", "Lyth", "Mor", "Nar", "Nyl", "Pesh", "Ssath", "Sser", "Ssla", "Ssyss", "Tla", "Xer", "Xyl", "Xyss"],
		"suff" : ["chal", "chyss", "geth", "hesh", "hyll", "kesh", "klatch", "lyss", "mash", "moth", "myss", "resh", "ron", "ryn", "tetch", "tek", "thyss", "toss", "xec", "yss"]
	},
	
	/* sits in for the d20 entry in the unborn */
	"Z" : ["I","II","III","IV","V","VI","VII","VIII","IX","X", "XI","XII","XIII","XIV","XV","XVI","XVII","XVIII","XIX","XX"]
};

names = {

	/*
	 * Random number in the ser [1, 20]
	 */ 
	rollD20 : function() {
		return Math.floor(Math.random()*20) + 1;
	},
	
	getName : function(type, genre) {
		var patternSet = patternTable[type];
		
		// get a random pattern
		var patternNum = names.rollD20();
				
		// select pattern
		var pattern = patternSet[1];
		for (var p in patternSet) {
			if (p <= patternNum) {
				pattern = patternSet[p];
			}
		}
		
		// turn pattern into a real name
		var name = names.makeName(pattern, genre);
		
		return name;
	},

	makeName : function(pattern, genre) {
		var name = "";
				
		var patternPart = "";
		for (var c = 0; c < pattern.length; ++c) {		
			var ch = pattern[c];			
			
			if (ch == "|") {
				// get the two next characters
				var c1 = pattern[c+1];
				var c2 = pattern[c+2];
				
				if (names.rollD20() < 11) {
					ch = c1;
				} else {
					ch = c2;
				}
				
				c += 2;
				patternPart += ch;
			} else if (ch == "[") {
				// end of pattern
				name += names.makeNamePart(patternPart, genre);
				patternPart = "";
				// jump over [
				++c;
				while (pattern[c] != "]") {
					name += pattern[c];
					++c;
				}
			} else if (ch == " ") {
				// end of pattern
				name += names.makeNamePart(patternPart, genre);
				patternPart = "";
				name += ch;
			} else {
				// add to pattern
				patternPart += ch;
			}
		}
		
		if (patternPart != "") {
			name += names.makeNamePart(patternPart, genre);
		}
		
		return name;
	},
	
	makeNamePart : function(patternPart, genre) {
		var namepart = "";
	
		for (var c = 0; c < patternPart.length; ++c) {
			var ch = patternPart[c];
			var part = names.getRandomPart(ch, genre, c == 0);
			
			if (c != 0) {
				// second half of a name
				
				// make lowercase
				part = part.toLowerCase();
				
				// blend if possible
				if (namepart[namepart.length-1] == part[0]) {
					part = part.substring(1);
				}
					
			}
			namepart += part;	
		}	
		
		return namepart;
	},

	getRandomPart : function(code, genre, isprefix) {
		
		var namelist = nameTable[code];
		
		if (!($.isArray(namelist))) {
			// if there is male/female choice		
			if (namelist["mâle"] !== undefined) {
				
				if (genre[0] == "m") {
					namelist = namelist["mâle"];
				} else {
					namelist = namelist["femelle"];
				}
				
			// if there is a prefix/sufffix choice
			} else if (namelist["pre"] !== undefined) {
				
				if (isprefix) {
					namelist = namelist["pre"];
				} else {
					namelist = namelist["suff"];
				}
			}			
		}
		
		var num = names.rollD20() - 1;
		
		return namelist[num];
		
	}
}
