
/* npc class */

npc = {
	title : "framboize",
	type : ["Humanoïde"],
	size : "Moyenne",
	animal : false,
	maxskills : 5,
	footprint : [1, 1],
	reach : 1,
	attr : { str : 10, con : 10, dex : 10, int : 10, wis : 10, cha : 10,
			 init : 1, atk : 1, def : 1, res : 1, ds : 1, comp : 1 },
	xp : 6,
	mobility : mobilitymanager.defaults["Marchant"].clone(),
	skills : [],
	spellcasting : {
		grade : 0,
		spells : []
	},
	attacks : [],
	gear : ["", ""],
	treasure : { any : 0, coin : 0, gear : 0, loot : 0, magic : 0, trophies : 0 },	
	qualities : [],
	
	/* setter and getter for npc type */
	setType : function(type) {
		this.type = type;
		this.updateFromType();
	},
	getType : function() {
		return this.type;
	},	
	
	/* setter and getter for npc size and related gubbins */
	setSize : function(size) {
		this.size = new String(size);
	},
	getSize : function() {
		return this.size;
	},
	setFootprint : function(footprint) {
		this.footprint = footprint;
	},
	getFootprint : function(footprint) {
		return this.footprint;
	},
	setReach : function(reach) {
		this.reach = reach;
	},
	getReach : function() {
		return this.reach;
	},
	
	/* setters and getters for mobility */
	setMobility : function(mobility) {
		this.mobility = mobility;
	},
	getMobility : function() {
		return this.mobility;
	},
	
	/* setter and getter for title */
	setTitle : function(title) {
		this.title = title;
	},
	getTitle : function() {
		return this.title;
	},
	
	getXP : function() {
		return this.xp;
	},
	
	/* setters and getters for attributes */
	setStr : function(str) {
		this.attr.str = parseInt(str);
	},
	getStr : function() {
		return this.attr.str;
	},
	setCon : function(con) {
		this.attr.con = parseInt(con);
	},
	getCon : function() {
		return this.attr.con;
	},
	setDex : function(dex) {
		this.attr.dex = parseInt(dex);
	},
	getDex : function() {
		return this.attr.dex;
	},
	setInt : function(int) {
		this.attr.int = parseInt(int);
		this.updatexp();
	},
	getInt : function() {
		return this.attr.int;
	},
	setWis : function(wis) {
		this.attr.wis = parseInt(wis);
	},
	getWis : function() {
		return this.attr.wis;
	},
	setCha : function(cha) {
		this.attr.cha = parseInt(cha);
	},
	getCha : function() {
		return this.attr.cha;
	},
	
	/* setters and getters for the roman numberal stats */
	setInit : function(init) {
		this.attr.init = parseInt(init);
	},
	getInit : function() {
		return this.attr.init;
	},
	setAtk : function(atk) {
		this.attr.atk = parseInt(atk);
	},
	getAtk : function() {
		return this.attr.atk;
	},
	setDef : function(def) {
		this.attr.def = parseInt(def);
	},
	getDef : function() {
		return this.attr.def;
	},
	setRes : function(res) {
		this.attr.res = parseInt(res);
	},
	getRes : function() {
		return this.attr.res;
	},
	setDS : function(ds) {
		this.attr.ds = parseInt(ds);
	},
	getDS : function() {
		return this.attr.ds;
	},
	setComp : function(comp) {
		this.attr.comp = parseInt(comp);
	},
	getComp : function() {
		return this.attr.comp;
	},
	setWlth : function(wlth) {
		this.attr.wlth = parseInt(wlth);
	},
	getWlth : function() {
		return this.attr.wlth;
	},
	
	/* the maximum number of skills the npc can have */
	getMaxSkills : function() {
		return this.maxskills;
	},
	
	/* functions for manipulating the skill list */
	setSkills : function(skills) {
		this.skills = skills;
	},
	
	getSkills : function() {
		return this.skills;
	},
		
	setskill : function(newskill) {		
		this.skills.push(newskill);
	},
	
	/* functions for manipulating spellcasting */
	getSpellcastingGrade : function() {
		return this.spellcasting.grade;
	},
	
	setSpellcastingGrade : function(grade) {
		this.spellcasting.grade = grade;
	},
	
	getSpells : function() {
		return this.spellcasting.spells;
	},
	
	setSpells : function(spells) {
		this.spellcasting.spells = spells;
	},	
	
	/* functions for manipulating the quality list */
	
	/*
	 * sets a quality, replacing any existing instance of
	 * the same quality.
	 */
	setquality : function(thequality) {
		// remove existing same quality
		this.removequality(thequality.name);		
		// add quality if xp is nonzero, unless the base xp is zero
		if (thequality.getxp() !== 0 || thequality.xp == 0) {
			this.qualities.push(thequality);
		}
	},
	
	/*
	 * removes a quality by name
	 */ 
	removequality : function(qualityname) {
		//identify quality to remove
		var qualityindex = -1;
		for (var q = 0; q < this.qualities.length; ++q) {
			var aquality = this.qualities[q];
			if (qualityname == aquality.name) {
				qualityindex = q;
			}
		}
		if (qualityindex >= 0) {
			//remove quality
			this.qualities.splice(qualityindex,1);
		}
	},
	
	/*
	 * gets the names of all the qualities attached to this npc
	 */
	getqualitynames : function() {
		var qualitynames = [];
		for (var q = 0; q < this.qualities.length; ++q) {
			var aquality = this.qualities[q];
			if (aquality !== null && aquality.name !== "") {
				qualitynames.push(aquality.name);
			}
		}
		return qualitynames.sort();
	},
	
	/*
	 * does this npc have any qualities
	 */
	hasqualities : function() {
		if (this.qualities.length > 0) {
			return true;
		} else {
			return false;
		}
	},
	
	/*
	 * gets a quality by name
	 */
	getquality : function(name) {
		for (var q = 0; q < this.qualities.length; ++q) {
			var aquality = this.qualities[q];
			if (aquality !== null && aquality.name == name) {
				return aquality;
			}
		}
		return null;
	},
	
	// functions for editing the attacks list	
	hasAttacks : function() {
		if (this.attacks.length > 0) {
			return true;
		} else {
			return false;
		}			
	},
	
	addAttack : function(attack) {
		this.attacks.push(attack);
	},
	
	removeAttack : function(index) {
		this.attacks.splice(index,1);
	},
	
	getAttacks : function(index) {
		return this.attacks;
	},
	
	getAttack : function(index) {
		return this.attacks[index];
	},
	
	setAttack : function(index, attack) {
		this.attacks[index] = attack;
	},
	
	
	/* getter and setter for gear */
	
	setGear : function(gear) {
		this.gear = gear;
	},
	
	getGear : function() {
		return this.gear;
	},
				
	/*
	 * called when the npc type changes
	 */
	updateFromType : function() {
		// if type is set to animal
		// max int = 6
	},
		
	/*
	 * recalculates the npc's xp value
	 */
	updatexp : function() {
				
		// xp total
		var xpcount = 0;
		
		// size/footprint/reach
		if (this.reach > 1) {
			xpcount += (this.reach - 1);
		}
		
		// type and mobility
		for (var i = 0; i < this.type.length; ++i) {
			xpcount += config.type[this.type[i]];
		}
		xpcount += this.mobility.getxp();
		
		// strength
		xpcount += Math.max(0, this.attr.str - 10);
		// dexterity
		xpcount += Math.max(0, this.attr.dex - 10);
		// constitution
		xpcount += Math.max(0, this.attr.con - 10);
		// intelligence
		xpcount += Math.max(0, this.attr.int - 10);
		// wisdom
		xpcount += Math.max(0, this.attr.wis - 10);
		// charisma
		xpcount += Math.max(0, this.attr.cha - 10);
		
		//initiative
		xpcount += this.attr.init;
		//attack
		xpcount += this.attr.atk;
		//defense
		xpcount += this.attr.def;
		//resilience
		xpcount += this.attr.res;
		//damage save
		xpcount += this.attr.ds;
		//competance
		xpcount += this.attr.comp;
		
		// skills
		if (this.skills !== null) {
			xpcount += skillmanager.skillsxp(this.skills);
		}
		
		// spellcasting
		xpcount += this.spellcasting.grade;
		
		// attacks
		for (var i = 0; i < this.attacks.length; ++i) {
			xpcount += this.attacks[i].getxp();
		}
		
		// qualities
		for (var q = 0; q < this.qualities.length; ++q) {
			var thequality = this.qualities[q];
			xpcount += thequality.getxp();
		}
		
		// set new XP total
		this.xp = xpcount;
		
		return xpcount;
	},
	
	/*
	 * writes the html representation of the npc stat block
	 */
	render : function() {
		
		this.updatexp();
		
		var output = "<div>";
		
		// initial parts in bold
		var titletext = this.renderTitleText();
		var title = "<strong class='blockstart'>" + titletext + "</strong>";
		output += title;
		
		// attributes
		output += " " + config.attributes[0] + " " + this.attr.str + ",";
		output += " " + config.attributes[1] + " " + this.attr.dex + ",";
		output += " " + config.attributes[2] + " " + this.attr.con + ",";
		output += " " + config.attributes[3] + " " + this.attr.int + ",";
		output += " " + config.attributes[4] + " " + this.attr.wis + ",";
		output += " " + config.attributes[5] + " " + this.attr.cha + ";";
		
		// size
		output += " Taille " + this.size.charAt(0) + " (" + this.footprint[0]+"×"+this.footprint[1]+", Allonge "+this.reach+");";
		
		// speed
		output += " Vitesse " + this.renderSpeed() + ";";
		
		// output stats
		//initiative
		output += " Init " + config.roman[this.attr.init] + ";";
		//attack
		output += " Att " + config.roman[this.attr.atk] + ";";
		//defense
		output += " Déf " + config.roman[this.attr.def] + ";";
		//resilience
		output += " Sauv " + config.roman[this.attr.res] + ";";
		//health
		output += " Santé " + config.roman[this.attr.ds] + ";";
		
		//competence
		if (this.attr.comp != 0) {
			output += " Comp " + config.roman[this.attr.comp] + ";";
		} else {
			output += " Comp —;";
		}
				
		// skills
		if (this.skills.length > 0) {
			output += " Compétences:";
			//use sorted copy of skill information
			var sortedSkills = [];
			var s;
			for (s = 0; s < this.skills.length; ++s) {
				sortedSkills.push(this.skills[s].name + "-" + this.skills[s].rating);
			}
			// add spellcasting to the list if in use
			if (this.spellcasting.grade > 0) {
				sortedSkills.push("Spellcasting" + "-" + this.spellcasting.grade);
			}
			sortedSkills = sortedSkills.sort();
			for (s = 0; s < sortedSkills.length; ++s) {
				var theskill = sortedSkills[s].split("-",2);
				output += " " + theskill[0] + " " + config.roman[parseInt(theskill[1], 10)];
				if (s == sortedSkills.length-1) {
					output += ";";
				} else {
					output += ",";
				}
			}
		}
		
		// spells
		if (this.spellcasting.spells.length > 0) {
			output += " Spells: ";
			for (var i = 0; i < this.spellcasting.spells.length; ++i) {
				if (i != 0) {
					output += ", ";					
				}
				output += $.trim(this.spellcasting.spells[i]);
			}
			output += ";";
		}
							
		// qualities
		output += this.renderQualities();		
		
		// attacks
		if (this.attacks.length > 0) {			
			output += "<br/><em class='blockstart'>Attaques/Armes:</em> ";			
			for (var i = 0; i < this.attacks.length; ++i) {
				if (i > 0) {
					output += ", ";
				}
				output += this.attacks[i].display();
			} 			
		}			
		
		// gear
		output += npc.renderGear();
		
		// treasure
		var treasure = npc.renderTreasure();
		if (treasure.trim() != "") {
			output += "<br/>" + treasure;
		}
		
		output += "</div>";
		
		return output;
	},
	
	renderTitleText : function() {
		var titleText = this.title + " (" + this.size;
		for (var i = 0; i < this.type.length; ++i) {	
			titleText += " " + this.type[i];
		}
		titleText += " " + this.mobility.displayName() + " — " + Math.max(0,this.xp) + " XP):";		
		return titleText;
	},
	
	renderSpeed : function() {
		var output = "";
		// if not immobile
		if (!this.mobility.isImmobile()) {
			
			// output primary first
			output += " " + this.mobility.speeds[this.mobility.primary] + " m. ";	
			output += config.mobilityMedium[mobilitymanager.names[this.mobility.primary]];
						
			for (var i = 0; i < 4; ++ i) {
				// skip iff primary
				if (i != this.mobility.primary && this.mobility.speeds[i] != 0) {					
					output += ", " + this.mobility.speeds[i] + " m. ";	
					output += config.mobilityMedium[mobilitymanager.names[i]];
				}				
			}

		}
		return output;
	},
	
	renderGear : function() {
		var output = "";
		if (this.gear[0] != "") {
			output += "<br/>";	
			output += "<em class='blockstart'>Mounts and Vehicles:</em> ";
			output += this.gear[0];
		}
		if (this.gear[1] != "") {
			output += "<br/>";
			output += "<em class='blockstart'>Gear:</em> ";
			output += this.gear[1];
		}			
		return output;
	},
	
	renderTreasure : function() {
		var output = "";
		var treasure = "<em class='blockstart'>Trésor:</em> ";
		var renderedSome = false;
		//any
		if (this.treasure.any > 0) {
			treasure += this.treasure.any + "A";
			renderedSome = true;
		}
		//coin
		if (this.treasure.coin > 0) {
			if (renderedSome) {
				treasure += ", ";
			}
			treasure += this.treasure.coin + "P";
			renderedSome = true;
		}
		//gear
		if (this.treasure.gear > 0) {
			if (renderedSome) {
				treasure += ", ";
			}
			treasure += this.treasure.gear + "E";
			renderedSome = true;
		}
		//loot
		if (this.treasure.loot > 0) {
			if (renderedSome) {
				treasure += ", ";
			}
			treasure += this.treasure.loot + "B";
			renderedSome = true;
		}
		//magic
		if (this.treasure.magic > 0) {
			if (renderedSome) {
				treasure += ", ";
			}
			treasure += this.treasure.magic + "M";
			renderedSome = true;
		}
		//trophies
		if (this.treasure.trophies > 0) {
			if (renderedSome) {
				treasure += ", ";
			}
			treasure += this.treasure.trophies + "T";
			renderedSome = true;
		}
		if (renderedSome) {
			output = treasure;
		}
		return output;
	},
	
	renderQualities : function() {
		var output = "<span>";
		if (this.qualities.length > 0) {			
			output += " Options: ";
			//make sorted copy of quality information
			var sortedQualities = [];
			var q;
			var thequality;
			for (q = 0; q < this.qualities.length; ++q) {
				thequality = this.qualities[q];
				if (thequality.name !== "") {
					sortedQualities.push(thequality.name + "----" + q);
				}
			}
			sortedQualities = sortedQualities.sort();
			for (q = 0; q < sortedQualities.length; ++q) {
				var qualityspec = sortedQualities[q].split("----",2);
				var qindex = parseInt(qualityspec[1], 10);
				thequality = this.qualities[qindex];
				output += thequality.render();
				if (q == sortedQualities.length-1) {
					output += ".";
				} else {
					output += ", ";
				}				
			}
		}
		output += "</span>";
		return output;
	},
	
	resetNPC : function() {

		this.title = "Nouveau PNJ";
		
		// size to medium			
		this.size = "Moyenne";
		// type to Humanoïde
		this.type = ["Humanoïde"];
		
		// reset to base values for everything
		this.mobility = mobilitymanager.defaults["Marchant"].clone();
		this.footprint = [1, 1];
		this.reach = 1;
		this.attr = { str : 10, con : 10, dex : 10, int : 10, wis : 10, cha : 10,
					  init : 1, atk : 1, def : 1, res : 1, ds : 1, comp : 1 },
		this.skills = [];
		this.qualities = [];
		this.attacks = [];		
		this.gear = ["", ""];
		this.spellcasting.grade = 0;
		this.spellcasting.spells = [];
		this.treasure = { any : 0, coin : 0, gear : 0, loot : 0, magic : 0, trophies : 0 }
	},
	
	parseNPC : function (text) {
		
		this.resetNPC();
				
		// compress white space
		text = text.replace(/\s+/mg, " ");
				
		// get title, split by :
		var npcspec = text.substring(0, text.indexOf(':'));
		var bloc = text.substring(text.indexOf(':')+1);
		
		// title
		var title = npcspec.split("(", 2);		
		this.setTitle(title[0].trim());
		
		// parse type
		var type = title[1];
		var mobilityTypes = this.parseType(type);
						
						
		// split into stat-block, attacks, gear and treasure
		// we do this by cutting them off in order of last to first
		var indexOfTreasure = bloc.toLowerCase().search("treasure:")
		if (indexOfTreasure > 0) {
			var treasure = bloc.substring(indexOfTreasure + 9);
			this.parseTreasure(treasure);
			bloc = bloc.substring(0, indexOfTreasure);
		}
		var indexOfGear = bloc.toLowerCase().search("gear:");
		if (indexOfGear > 0) {
			var gear = bloc.substring(indexOfGear + 5);
			this.parseGear(gear);
			bloc = bloc.substring(0, indexOfGear);
		}
		var indexOfMaV = bloc.toLowerCase().search("mounts and vehicles:");
		if (indexOfMaV > 0) {
			var mav = bloc.substring(indexOfMaV + 20);
			this.parseMaV(mav);
			bloc = bloc.substring(0, indexOfMaV);
		}
		var indexOfAttacks = bloc.toLowerCase().search('Attaques/Armes:');
		if (indexOfAttacks > 0) {
			var attacks = bloc.substring(indexOfAttacks + 16);
			this.parseAttacks(attacks);
			bloc = bloc.substring(0, indexOfAttacks);
		}
		// we are now left with just the stat block
		
		// split by ;
		var info = bloc.split(";");
		for (var i = 0; i < info.length; ++i) {
			info[i] = info[i].trim();
			if (info[i] !== "") {
				// seperate name from value(s)
				var datum;
				var indexOfColon = info[i].search(':');
				if (indexOfColon > 0) {					
					datum = new Array();
					datum[0] = info[i].substring(0, indexOfColon);
					datum[1] = info[i].substring(indexOfColon+1);
				} else {
					var indexOfWhiteSpace = info[i].search(/\s+/);
					datum = new Array();
					datum[0] = info[i].substring(0, indexOfWhiteSpace);
					datum[1] = info[i].substring(indexOfWhiteSpace+1);
				}
				datum[1] = datum[1].trim();
				// get quality category, remove any trailing non alphabetic characters
				var qcat = datum[0].trim().replace(/^\W+|\W+$/g, '');	
				
				switch(qcat.toLowerCase()) {
				case 'str':
					this.parseAttributes(qcat + " " + datum[1]);
					break;
				case 'init':
					this.attr.init = config.roman.indexOf(datum[1]);
					break;
				case 'atk':
					this.attr.atk = config.roman.indexOf(datum[1]);
					break;
				case 'def':
					this.attr.def = config.roman.indexOf(datum[1]);
					break;
				case 'res':
				case 'resilience':
					this.attr.res = config.roman.indexOf(datum[1]);
					break;
				case 'health':
					this.attr.ds = config.roman.indexOf(datum[1]);
					break;
				case 'comp':
				case 'competence':
					this.attr.comp = config.roman.indexOf(datum[1]);
					if (this.attr.comp == -1) {
						this.attr.comp = 0;
					}
					break;
				case 'sz':
					this.parseSize(datum[1]);
					break;
				case 'spd':
				case 'speed':
					this.parseSpeed(datum[1], mobilityTypes);
					break;
				case 'skills':
					this.parseSkills(datum[1]);
					break;
				case 'spells':
					this.parseSpells(datum[1]);
					break;
				case 'qualities':
					this.parseQualities(datum[1]);
					break;
				}
			}
		}
		
		// finally update the xp value
		this.updatexp();
	},
	
	parseType : function(text) {
		// remove xp from text
		text = text.replace(/[-—].*$/,"");
		
		// split by white space
		var words = text.split(/\s+/);		
		
		// first word is size
		this.size = words[0].toCapCase();
		
		// second or more could be type
		var type = [];
		var wordIndex = 1;
		var word = words[wordIndex];
		while (config.types.indexOf(word) >= 0) {
			if (config.types.indexOf(word) >= 0) {
				type.push(word);
				++wordIndex;
				word = words[wordIndex];
			}
		}
		this.type = type;
		
		// third word is mobility type, potentially split by '/'
		var mobilityTypes = words[wordIndex].split("http://my-svn.assembla.com/");
		this.mobility.primary = mobilitymanager.names.indexOf(mobilityTypes[0].toCapCase());
		return mobilityTypes;
	},
	
	parseAttributes : function(text) {
		//Str 10, Dex 12, Con 10, Int 10, Wis 5, Cha 14
		var attrs = text.split(/,\s+/);
		for (var i = 0; i < attrs.length; ++i) {
			var attr = attrs[i].substr(0,3);
			var score = parseInt(attrs[i].substring(4));
			switch(attr.toLowerCase()) {
				case 'str':
					this.attr.str = score;
					break;
				case 'dex':
					this.attr.dex = score;
					break;
				case 'con':
					this.attr.con = score;
					break;
				case 'int':
					this.attr.int = score;
					break;
				case 'wis':
					this.attr.wis = score;
					break;
				case 'cha':
					this.attr.cha = score;
					break;					
			}
		}
	},
	
	parseSize : function(text) {
		// sz this.size.charAt(0) + " (" + this.footprint[0]+"×"+this.footprint[1]+", Reach "+this.reach+");";
		
		var sizechar = text.substring(0, text.indexOf("(")).trim();
		
		// match letter to size
		for (var i = 0; i < config.size.length; ++i ) {
			var size = config.size[i];
			if (size.toLowerCase().charAt(0) == sizechar.toLowerCase()) {
				this.size = size;
				break;
			}
		}
		
		// cut size char off the begining
		text = text.substring(text.indexOf("("));
		var parttext = text.replace(/^[^\d]*(\d+)[^\d]*(\d+)[^\d]*(\d+)[^\d]*$/m, "$1,$2,$3");
		var parts = parttext.split(",");
		
		this.footprint[0] = parseInt(parts[0]);
		this.footprint[1] = parseInt(parts[1]);
		this.reach = parseInt(parts[2]);
		
	},
	
	parseSpells : function(text) {
		// split by commas
		this.spellcasting.spells = text.split(/,\s+/);
	},
	
	parseMaV : function(text) {
		this.gear[0] = text.trim();
	},
	
	parseGear : function(text) {
		this.gear[1] = text.trim();
	},
	
	parseSpeed : function(text, mobilityTypes) {		
		
		
		// get the numbers
		var speeds = text.toLowerCase().split(",");
		if (speeds.length > 0 && mobilityTypes.length > 0) {
			var speed = speeds[0].substring(0,speeds[0].indexOf("ft"));
			var speedIndex = mobilitymanager.names.indexOf(mobilityTypes[0].toCapCase());			
			this.mobility.speeds[speedIndex] = parseInt(speed);
		}
		if (speeds.length > 1 && mobilityTypes.length > 1) {
			var speed = speeds[1].substring(0,speeds[1].indexOf("ft"));
			var speedIndex = mobilitymanager.names.indexOf(mobilityTypes[1].toCapCase());			
			this.mobility.speeds[speedIndex] = parseInt(speed);
		}
		if (speeds.length > 2 && mobilityTypes.length > 2) {
			var speed = speeds[2].substring(0,speeds[2].indexOf("ft"));
			var speedIndex = mobilitymanager.names.indexOf(mobilityTypes[2].toCapCase());			
			this.mobility.speeds[speedIndex] = parseInt(speed);
		}	
		if (speeds.length > 3 && mobilityTypes.length > 3) {
			var speed = speeds[3].substring(0,speeds[3].indexOf("ft"));
			var speedIndex = mobilitymanager.names.indexOf(mobilityTypes[3].toCapCase());			
			this.mobility.speeds[speedIndex] = parseInt(speed);
		}	
	},
	
	parseTreasure : function(text) {
		// 4C, 2L, 4T
		
		var rewards = text.trim().toLowerCase().split(/\s*,\s+/);
		for (var i = 0; i < rewards.length; ++i) {
			// split the number and code
			var code = rewards[i].charAt(rewards[i].length-1);
			var number = parseInt(rewards[i].substring(0, rewards[i].length-1));
			
			switch (code) {
				//any
				case 'a':
					this.treasure.any = number;
					break;
				//coin
				case 'c':
					this.treasure.coin = number;
					break;
				//gear
				case 'g':
					this.treasure.gear = number;
					break;
				//loot
				case 'l':
					this.treasure.loot = number;
					break;
				//magic
				case 'm':
					this.treasure.magic = number;
					break;
				//trophies
				case 't':
					this.treasure.trophies = number;
					break;
			}			
		}
	},
	
	parseAttacks : function(text) {
		// split into seperate attacks where each fits the pattern
		// title (description),
		
		var parts = text.split(/,(?![^\(]*\))/g);
		for (var i = 0; i < parts.length; ++i) {
			// split by the openning bracket
			var name, description;
			if (parts[i].indexOf("(") > 0) {
				name = parts[i].substring(0, parts[i].indexOf("(")).trim();
				description = parts[i].substring(parts[i].indexOf("(")+1);
				description = description.replace(/[\(\)]/m, "").trim();
			} else {
				name = parts[i];
				description = "";
			}
			var attack = attacksconfig.parseAttack(name, description);
			
			this.addAttack(attack);
		}
	},
	
	parseSkills : function(text) {
		
		var listing;
		if (text.indexOf(',') > 0) {
			listing = text.split(',');
		} else {
			listing = [];
			listing[0] = text;
		}
		
		for (var i = 0; i < listing.length; ++i) {
			listing[i] = listing[i].trim();
			var breakdown = listing[i].split(/\s/);
			// separate values
			var skillname = breakdown[0].trim();
			var skillrating = breakdown[1];
			if (breakdown.length > 2) {
				skillrating = breakdown[breakdown.length-1];
				for (var j = 1; j < breakdown.length-1; ++j) {
					skillname += " " + breakdown[j];
				}
			}
			
			// deal with spellcasting special case
			if (skillname.toLowerCase() == 'spellcasting') {
				this.spellcasting.grade = config.roman.indexOf(skillrating);
			} else {
				// make skill
				var skill = new Skill(skillname, config.roman.indexOf(skillrating));
				// add to array
				this.skills.push(skill);
			}
		}
	},
	
	parseQualities : function(text) {
		// split carefully
		var qualities = text.split(/,(?![^\(]*\))/g);
		/*
		 * catches all commas which are not followed by the pattern
		 * [^\(]*\)
		 * which matches when there is an openning bracket before
		 * the next closing bracket
		 */
		
		for (var q = 0; q < qualities.length; ++q) {
			// parse the quality
			var thequality = qualitymanager.parseQuality(qualities[q].trim());
			// add to array
			if (thequality !== null) {
				this.setquality(thequality, false);
			}
		}
	}
};
