
function SkillsDialog() {
	this.base = NPCDialog;
	this.base("Edition de Compétences", true, "edit-skill-form");
}
SkillsDialog.prototype = new NPCDialog();

SkillsDialog.prototype.ok = function() {
	var skills = this.getSkillsFromDialog();
	npc.setSkills(skills);
}

SkillsDialog.prototype.open = function() {
	this.base.prototype.open.call(this);
	
	var dialogInstance = this;
	
	// calculate the initial xp
	var skills = dialogInstance.getSkillsFromDialog();
	var xp = dialogInstance.getXpTotalFromSkills(skills);
	dialogInstance.updateXP(xp);
	
	// assign actions, same for all the selects
	$("#skilleditarea select").change(function(){
		// get a skill list
		var skilllist = dialogInstance.getSkillsFromDialog();
		// calculate the xp
		var xp = dialogInstance.getXpTotalFromSkills(skilllist);
		// update the xp onscreen
		dialogInstance.updateXP(xp);
	});
	
}

SkillsDialog.prototype.getFormContent = function() {
	
	var dialogInstance = this;
	
	var output = "<div id='skilleditarea'>";
	var skills = npc.getSkills();
	for (var i = 0; i < npc.getMaxSkills(); ++i) {
		var selected = "undefined";
		var skillrating = 0;
		// if it has a skill
		if (i < skills.length) {
			selected = skills[i].name;
			skillrating = skills[i].rating;
		}
		var allskills = config.skills;
		if (npc.animal) {
			allskills = config.animalskills;
		}
		output += npcutil.getListSelector("skill-"+i, allskills, true, selected);
		output += npcutil.getRomanSelector("rating-"+i, 1, 10, skillrating);
		output += "<br class='fatbreak'/>";
	}
	
	output += "</div>";
	
	return output;	
}

SkillsDialog.prototype.getSkillsFromDialog = function() {
	var skills = [];
	for (var i = 0; i < npc.getMaxSkills(); ++i) {
		var name = $("#skilleditarea #skill-"+i).val();
		if (name != "") {
			var rating = parseInt($("#skilleditarea #rating-"+i).val());
			skills.push(new Skill(name, rating));
		}
	}
	return skills;
}
	
SkillsDialog.prototype.getXpTotalFromSkills = function(skills) {
	return skillmanager.skillsxp(skills);
}
