
function SpellcastingDialog() {
	this.base = NPCDialog;
	this.base("Incantation", true, "spellcasting-dialog");
}
SpellcastingDialog.prototype = new NPCDialog();

SpellcastingDialog.prototype.ok = function() {
	var grade = parseInt($("#spellcastingGrade").val());
	var spells = this.getSpellsFromForm();
	npc.setSpellcastingGrade(grade);
	npc.setSpells(spells);
}

SpellcastingDialog.prototype.open = function() {
	this.base.prototype.open.call(this);
	
	var dialogInstance = this;
	
	// calculate the initial xp
	dialogInstance.updateXP(parseInt($("#spellcastingGrade").val()));
	
	// assign actions, same for all thing inside the edit area
	$("#spellcastingGrade").change(function(){
		var grade = parseInt($("#spellcastingGrade").val());
		// update the xp
		dialogInstance.updateXP(grade);
		// update the number of spell inputs
		var spells = dialogInstance.getSpellsFromForm();
		$("#spellListArea").html(dialogInstance.getSpellInputs(grade, spells));
	});
}

SpellcastingDialog.prototype.getFormContent = function() {
	var output = "";
	
	var grade = npc.getSpellcastingGrade();
	
	// grade selector
	output += "Degré de compétence:&nbsp;";
	output += npcutil.getRomanSelector("spellcastingGrade", 0, 10, grade);
	
	output += "<div id='spellListArea'>";
	output += this.getSpellInputs(grade, npc.getSpells());
	output += "</div>";
	
	return output;
}

SpellcastingDialog.prototype.getSpellsFromForm = function() {
	var spells = [];
	
	$("#spellListArea .spellinput").each(function() {
		spells.push(npcutil.sanitizeCustomText($(this).val()));
	});
	
	return spells;
}

SpellcastingDialog.prototype.getSpellInputs = function(quantity, spells) {
	var output = "";
	if (quantity > 0) {
		for (i = 0; i < quantity; ++i) {
			output += "<br/>";
			output += "<input class='spellinput' type='text'";
			if (spells[i]) {
				output += " value='"+spells[i]+"'"
			}
			output += "/>";
		}
	}
	return output;
}
