
function TypeDialog() {
	this.base = NPCDialog;
	this.base("Type", true, "edit-type-form");
}
TypeDialog.prototype = new NPCDialog();


TypeDialog.prototype.ok = function() {
	var type = this.getTypesFromForm();
	npc.setType(type);
}

TypeDialog.prototype.getButtons = function() {
	var dialogInstance = this;
	
	return { 
		"Ok" : function() {			
			if($("#edittypearea input[checked]").length == 0) {
				alert("Vous devez sélectionner au moins un type");
			} else {
				dialogInstance.disable();
				dialogInstance.ok();
				dialogInstance.close();
				view.renderNPC();
			}
		}, 
		"Annuler" : function() { 
			dialogInstance.close();
		}
	}
}

TypeDialog.prototype.open = function() {
	this.base.prototype.open.call(this);
	
	var dialogInstance = this;
	
	$("#edittypearea input.typeinput").change(function(){
		dialogInstance.updateXP(dialogInstance.xpFromForm());
	});
	
	dialogInstance.updateXP(dialogInstance.xpFromForm());
}

TypeDialog.prototype.getFormContent = function() {
			
	var output = "<div id='edittypearea'>";
	
	for (var i = 0; i < config.types.length; ++i) {
		output += "<input class='typeinput' type='checkbox' value='" + config.types[i];
		if (npc.getType().indexOf(config.types[i]) >= 0) {
			output += "' checked='checked";
		}
		output += "' id='typeitem-" + i + "'/>"
		output += "<label for='typeitem-" + i + "'>"
		output += config.types[i];
		output += "</label>";
		output += "<br/>";
	}
	
	output += "</div>";
	
	return output;
}

TypeDialog.prototype.getTypesFromForm = function() {
	var type = [];
	$("#edittypearea input").each(function(){
		if ($(this).attr("checked")) {
			var val = $(this).val();
			type.push(val);
		}
	})
	return type;
}

TypeDialog.prototype.xpFromForm = function() {
	var xp = 0;
	
	var type = this.getTypesFromForm();
	
	for (var i = 0; i < type.length; ++i) {
		xp += config.type[type[i]];
	}
	
	return xp;
}
