
$(document).ready(function(){
	view.setupInitialPage();
});
 
// a couple of custom jquery commands for enabling and disabling things
jQuery.fn.enable = function() {
	return this.each(function() {
		this.disabled = false;
		return $(this).removeClass("ui-state-disabled");	
	});
};
  	
jQuery.fn.disable = function() {
	return this.each(function() {
		this.disabled = true;
		return $(this).addClass("ui-state-disabled");
	});
};

jQuery.fn.styleInput = function() {
	var inputSelector = "button,select";
	// do not style the selects in ie
	if ($.browser.msie) {
		inputSelector = "button";
	}
	this.filter(inputSelector).each(function(){
		$(this).addClass("ui-state-default");
		$(this).addClass("ui-corner-all");
		$(this).unbind("hover");
		$(this).hover(
			function(){
				$(this).addClass("ui-state-hover");
			},
			function(){
				$(this).removeClass("ui-state-hover");
			});
		$(this).filter(":disabled").addClass("ui-state-disabled");
	});
	this.filter("input:text").each(function(){
		$(this).addClass("ui-corner-all");
		$(this).addClass("ui-my-text-input");
	});
	return this;	
};

jQuery.fn.styleInputs = function() {
	return this.each(function(){
		$(this).find("button,select,input:text").styleInput();
	});
}

view = {
	
	skillDialog : null,
	mobilityDialog : null,
	typeDialog : null,
	editQualitiesDialog : null,
	treasureDialog : null,
	editAttacksDialog : null,
	spellcastingDialog : null,
	gearDialog : null,
	loadNPCDialog : null,
	nameDialos : null,
	
	setupInitialPage : function() {
  						
		// run config loading functions
		config.setSkillStats();
		config.setQualities();		
		
		//load npc from cookie
		var storednpc = cookiemanager.getnpc();
		if (storednpc != null) {
			npc.parseNPC(storednpc);
		}
		
		// activate tabs in edit area
		view.editnpc();
	},
	
	editnpc : function() {
		
		//setup the edit area events
		view.setupEditArea();
		
		$("body").styleInputs();
	},
	
	setupEditArea : function() {
		// setup dialogs
		view.setupSkillDialog();
		view.setupTreasureDialog();
		view.setupAttacksDialog();
		view.setupEditAttacksDialog();
		view.setupSpellcastingDialog();
		view.setupGearDialog();
		view.setupAddQualityDialog();
		view.setupEditQualitiesDialog();
		view.reviewEditQualitiesButton();
		view.setupMobilityDialog();
		view.setupTypeDialog();
		view.setupNameDialog();
		view.setupLoadNPCDialog();
		view.reviewEditAttacksButton();
		
		// display title in input
		$("#title").val(npc.getTitle());
		
		// replace all the stat selectors so that the current value is selected
		$("#init").replaceWith(npcutil.getRomanSelector("init",1,10,npc.getInit()));
		$("#atk").replaceWith(npcutil.getRomanSelector("atk",1,10,npc.getAtk()));
		$("#def").replaceWith(npcutil.getRomanSelector("def",1,10,npc.getDef()));
		$("#res").replaceWith(npcutil.getRomanSelector("res",1,10,npc.getRes()));
		$("#ds").replaceWith(npcutil.getRomanSelector("ds",1,10,npc.getDS()));
		$("#comp").replaceWith(npcutil.getRomanSelector("comp",0,10,npc.getComp()));
		
		$("#str").replaceWith(npcutil.getNumericSelector("str",1,99,npc.getStr()));
		$("#dex").replaceWith(npcutil.getNumericSelector("dex",1,99,npc.getDex()));
		$("#con").replaceWith(npcutil.getNumericSelector("con",1,99,npc.getCon()));
		$("#int").replaceWith(npcutil.getNumericSelector("int",1,99,npc.getInt()));
		$("#wis").replaceWith(npcutil.getNumericSelector("wis",1,99,npc.getWis()));
		$("#cha").replaceWith(npcutil.getNumericSelector("cha",1,99,npc.getCha()));
		
		$("#size").replaceWith(npcutil.getListSelector("size", config.size, false, npc.getSize()));
		$("#footprintx").replaceWith(npcutil.getNumericSelector("footprintx",1,99,npc.getFootprint()[0]));
		$("#footprinty").replaceWith(npcutil.getNumericSelector("footprinty",1,99,npc.getFootprint()[1]));
		$("#reach").replaceWith(npcutil.getNumericSelector("reach",0,99,npc.getReach()));
		
		// attach event to chainging the npc title and type
		$("#title").change(function(){
			npc.setTitle($("#title").val());
			view.renderNPC();
		});
		
		// attach events to size selectors
		$("#size").change(function(){
			npc.setSize($("#size").val());
			view.renderNPC();
		});
		$("#footprintx").change(function(){
			npc.setFootprint([$("#footprintx").val(), $("#footprinty").val()]);
			view.renderNPC();
		});
		$("#footprinty").change(function(){
			npc.setFootprint([$("#footprintx").val(), $("#footprinty").val()]);
			view.renderNPC();
		});
		$("#reach").change(function(){
			npc.setReach($("#reach").val());
			view.renderNPC();
		});
			
		// attach events to all of the stat selectors
		$("#str").change(function(){
			npc.setStr($("#str").val());
			view.renderNPC();
		});
		$("#dex").change(function(){
			npc.setDex($("#dex").val());
			view.renderNPC();
		});
		$("#con").change(function(){
			npc.setCon($("#con").val());
			view.renderNPC();
		});
		$("#int").change(function(){
			npc.setInt($("#int").val());
			view.renderNPC();
		});
		$("#wis").change(function(){
			npc.setWis($("#wis").val());
			view.renderNPC();
		});
		$("#cha").change(function(){
			npc.setCha($("#cha").val());
			view.renderNPC();
		});
		$("#init").change(function(){
			npc.setInit($("#init").val());
			view.renderNPC();
		});
		$("#atk").change(function(){
			npc.setAtk($("#atk").val());
			view.renderNPC();
		});
		$("#def").change(function(){
			npc.setDef($("#def").val());
			view.renderNPC();
		});
		$("#res").change(function(){
			npc.setRes($("#res").val());
			view.renderNPC();
		});
		$("#ds").change(function(){
			npc.setDS($("#ds").val());
			view.renderNPC();
		});
		$("#comp").change(function(){
			npc.setComp($("#comp").val());
			view.renderNPC();
		});
		
		
		$("#load-npc").click(function(){
			view.loadNPCDialog.open();
		});
		$("#new-npc").click(function(){
			var confirmation = confirm("Ceci efface votre actuel PNJ, continuer ?");
			if (confirmation) {
				npc.resetNPC();
				view.renderNPC();
				view.updateEditAreaFromNPC();
			}
		});
		
		// attach events to the edit buttons
		$("#edit-type").click(function(){
			view.typeDialog.open();
		});
		
		$("#edit-mobility").click(function(){
			view.mobilityDialog.open();
		});
		
		$("#random-name").click(function(){
			view.nameDialog.open();
		});
		
		$("#edit-skill").click(function(){
			view.skillDialog.open();
		});
		
		$("#edit-treasure").click(function(){
			view.treasureDialog.open();
		});
		
		$("#add-attack").click(function(){
			view.openAddAttackDialog();
		});
		
		$("#edit-attacks").click(function(){
			view.editAttacksDialog.open();
		});
		
		$("#edit-spellcasting").click(function(){
			view.spellcastingDialog.open();
		});
		
		$("#edit-gear").click(function(){
			view.gearDialog.open();
		});
		
		$("#add-quality").click(function(){
			view.openAddQualityDialog();
		});
		
		$("#edit-qualities").click(function(){
			view.editQualitiesDialog.open();
		});
				
		// display the stat block
		view.renderNPC();		
	},
	
	updateEditAreaFromNPC : function() {
		
		// display title in input
		$("#title").val(npc.getTitle());
		
		// display the type selector
		$("#type").val(npc.getType());
		
		// replace all the stat selectors so that the current value is selected
		$("#init").val(npc.getInit());
		$("#atk").val(npc.getAtk());
		$("#def").val(npc.getDef());
		$("#res").val(npc.getRes());
		$("#ds").val(npc.getDS());
		$("#comp").val(npc.getComp());
		$("#wlth").val(npc.getWlth());
		
		$("#str").val(npc.getStr());
		$("#dex").val(npc.getDex());
		$("#con").val(npc.getCon());
		$("#int").val(npc.getInt());
		$("#wis").val(npc.getWis());
		$("#cha").val(npc.getCha());
		
		$("#size").val(npc.getSize());
		$("#footprintx").val(npc.getFootprint()[0]);
		$("#footprinty").val(npc.getFootprint()[1]);
		$("#reach").val(npc.getReach());
		
	},
	
	setupLoadNPCDialog : function() {
		this.loadNPCDialog = new LoadNPCDialog();
	},
	
	setupTypeDialog : function() {
		this.typeDialog = new TypeDialog();
	},
	
	setupMobilityDialog : function() {
		this.mobilityDialog = new MobilityDialog();
	},
	
	setupNameDialog : function() {
		this.nameDialog = new NameDialog();
	},
	
	setupSkillDialog : function() {		
		this.skillDialog = new SkillsDialog();
	},
	
	setupTreasureDialog : function() {
		this.treasureDialog = new TreasureDialog();
	},
	
	setupEditAttacksDialog : function() {
		this.editAttacksDialog = new EditAttacksDialog();
	},
	
	setupSpellcastingDialog : function() {
		this.spellcastingDialog = new SpellcastingDialog();
	},
	
	setupGearDialog : function() {		
		this.gearDialog = new GearDialog();
	},
	
	setupEditQualitiesDialog : function() {
		this.editQualitiesDialog = new EditQualitiesDialog();
	},
	
	setupAttacksDialog : function() {
		
		// setup the dialog
		$("#add-attack-dialog").dialog({
			title : "Ajout Attaque/Arme",
			autoOpen : false,
			modal : true,
			height : 'auto',
			width : 'auto',
			autoResize : true,
			overlay : { 
				opacity : 0.1, 
				background : "black" 
			},
			buttons : { 
				"Annuler" : function() { 
					$(this).dialog("close");
				}
			}
		});
		
		$("#add-attack-dialog #add-weapon-attack").click(function(){
			var attack = new WeaponAttack();
			var attackDialog = new AttackDialog("Nouvelle Arme", attack);
			attackDialog.open();			
		});
		
		$("#add-attack-dialog #add-natural-attack").click(function(){
			var attack = new NaturalAttack();
			var attackDialog = new AttackDialog("Nouvelle Attaque Naturelle", attack);
			attackDialog.open();			
		});
		
		$("#add-attack-dialog #add-damage-extraordinary-attack").click(function(){
			var attack = new DamageEOAttack();
			var attackDialog = new AttackDialog("Nouvelle Attaque de Dégâts", attack);
			attackDialog.open();			
		});
		
		$("#add-attack-dialog #add-save-extraordinary-attack").click(function(){
			var attack = new SaveEOAttack();
			var attackDialog = new AttackDialog("Nouvelle Attaque à Effets", attack);
			attackDialog.open();			
		});
	},
	
	reviewEditAttacksButton : function() {
		// are there any attacks
		if (npc.hasAttacks()) {
			// enable the button
			$("#edit-attacks").enable();
		} else {
			// disable the button
			$("#edit-attacks").disable();
		}		
	},

	openAddAttackDialog : function() {
		$("#add-attack-dialog").dialog("open");
	},
	
	closeAddAttacksDialog : function() {
		$("#add-attack-dialog").dialog("close");
	},
	
	reviewEditQualitiesButton : function() {
		// if there are any npc qualities set
		if(npc.hasqualities()) {
			// enable the button
			$("#edit-qualities").enable();
		} else {
			// disable the button
			$("#edit-qualities").disable();
		}
	},
	
	// updated the npc stats on screen and within the print view
	renderNPC : function() {
		$("#statblock").html(npc.render());
		cookiemanager.savenpc($("#statblock").text());
	},
	
	setupAddQualityDialog : function() {
		// dialog content
		var output = "<div id='dialogContent'>";
		output += view.getAddQualityDialogContent();
		output += "</div>";
		
		// set the content
		$("#add-quality-dialog").html(output);
		$("#add-quality-dialog #dialogContent").styleInputs();
		
		// setup the dialog
		$("#add-quality-dialog").dialog({
			title : "Options",
			autoOpen : false,
			modal : true,
			height : 'auto',
			width : 'auto',
			autoResize : true,
			overlay : { 
				opacity : 0.1, 
				background : "black" 
			},
			buttons : { 
				"Ok" : function() { 
					view.addQualityDialogOK();
					$(this).dialog("close");
					view.renderNPC();
				}, 
				"Annuler" : function() { 
					$(this).dialog("close");
				}
			}
		});
		
	},
	
	openAddQualityDialog : function() {
		$("#add-quality-dialog").dialog("open");
	},
	
	getAddQualityDialogContent : function() {
		var output = "<div id='addqualityarea'>";
		output += "<select id='qualitylist'>";
		
		var keys = config.supplimentQualities.getKeys();
			
		for (k = 0; k < keys.length; ++k) { // for each suppliment
			if (keys[k] != "hidden qualities") {
				var qualities = config.supplimentQualities.getItem(keys[k]);
				if (qualities.length > 0) {
					output += "<optgroup label='" + keys[k] + "'>";
					for (var q = 0; q < qualities.length; ++q) { // for each quality
						if(qualities[q]) {					
							output += "<option value='";
							output += qualities[q].name + "'>"
							if (qualities[q].restrictions !== null) {
								output += qualities[q].name + " (" + qualities[q].restrictions + ")";
							} else {
								output += qualities[q].name;
							}
							output += "</option>";
						}
					}
					output += "</optgroup>";
				}
			}
		}
		
		output += "</select>";
		output += "</div>";
		
		return output;	
	},
	
	addQualityDialogOK : function() {
		// determine quality selected
		var qname = $("#qualitylist").val();
		// does the npc have a quality with this name already?
		var quality = npc.getquality(qname);
		
		if (quality == null) {
			quality = qualitymanager.getRawQuality(qname);
			quality.makeused();
		}
		
		// work with a copy
		quality = quality.clone();
		
		// create a quality edit dialog
		var qualityDialog = new QualityDialog(quality);
		
		// open the dialog
		qualityDialog.open();
	}
	
};
