
function NPCDialog(title, hasXP, divId) {
	this.title = title;	
	this.hasXP = hasXP;
	this.divId = divId;
}

NPCDialog.prototype.getTitle = function() {
	return this.title;
}

NPCDialog.prototype.getDivId = function() {
	return this.divId;
}

NPCDialog.prototype.getButtons = function() {
	var dialogInstance = this;
	
	return { 
		"Ok" : function() {
			dialogInstance.disable();
			dialogInstance.ok();
			dialogInstance.close();
			view.renderNPC();
		}, 
		"Annuler" : function() { 
			dialogInstance.close();
		}
	}
}

NPCDialog.prototype.disable = function() {
	var dialogInstance = this;
	$("#"+dialogInstance.getDivId()).dialog("enable");
};

NPCDialog.prototype.close = function() {
	var dialogInstance = this;
	$("#"+dialogInstance.getDivId()).dialog("close");
	$("#"+dialogInstance.getDivId()).dialog("destroy");
	$("#" + dialogInstance.getDivId()).remove();
}

NPCDialog.prototype.setUp = function() {
	
	var dialogInstance = this;
	
	// create a div for the dialog
	$("#footer").append("<div id='" + dialogInstance.getDivId() + "'></div>");
			
	// make it a dialog
	$("#"+dialogInstance.getDivId()).dialog({
		title : dialogInstance.title,
		autoOpen : false,
		modal : true,
		height : 'auto',
		width : 'auto',
		minWidth : 300,
		maxWidth: 700,
		dialogClass : 'npcDialog',
		autoResize : true,
		overlay : { 
			opacity : 0.1, 
			background : "black" 
		},
		buttons : dialogInstance.getButtons()
	});
	
	// set the content
	$("#"+dialogInstance.getDivId()).html(dialogInstance.getContent());
	
};

NPCDialog.prototype.open = function() {
	
	var dialogInstance = this;
	
	dialogInstance.setUp();
	$("#"+dialogInstance.getDivId() + " div#dialogContent").styleInputs();
	
	// open the dialog
	$("#"+dialogInstance.getDivId()).dialog("open");
	$("#"+dialogInstance.getDivId()).dialog("enable");
	
};

NPCDialog.prototype.ok = function() {};

NPCDialog.prototype.getContent = function() {
	var output = "<div id='dialogContent'>";
	output += this.getFormContent();
	if(this.hasXP) {
		output += "<hr/><strong id='dialogxptotal'>0 XP</strong>";
	}
	output += "</div>";
	return output;
};

NPCDialog.prototype.getFormContent = function() {
	return "";
};

NPCDialog.prototype.updateXP = function(xp) {
	$("#" + this.divId + " #dialogxptotal").text(xp + " XP");
}
